NuttyWarAnnounce = LibStub("AceAddon-3.0"):NewAddon("NuttyWarAnnounce", "AceConsole-3.0", "AceEvent-3.0")
local Media = LibStub("LibSharedMedia-3.0")

--default settings--
local defaults = {
    profile =  {
		readycheckoptions = false,
		partyannounce = false,
		raidannounce = false,
		raidwarningannounce = false,
		sayannounce = false,
		yellannounce = false,
		whisperannounce = false,
		whispercustom = "Player Name",
		nuttychatchanannounce = false,
		customchanannounce = false,
		customchancustom = "Channel Name",
		battleshoutall = false,
		battleshoutcustomall = "Type your custom Announce",
		battleshoutfadedall = false,
		battleshout = false,
		battleshoutsound = "none",
		battleshoutcustom = "Type your custom Announce",
		commandingshoutall = false,
		commandingshoutcustomall = "Type your custom Announce",
		commandingshoutfadedall = false,
		commandingshout = false,
		commandingshoutsound = "none",
		commandingshoutcustom = "Type your custom Announce",
		demosound = "none",
		demo = false,
		democustom = "Type your custom Announce",
		thunderclapsound = "none",
		thunderclaptoggle = false,
		thunderclapcustom = "Type your custom Announce",
		rendsound = "none",
		rendcustomtoggle = false,
		rendcustom = "Type your custom Announce",
		mortalstrikesound = "none",
		mortalstrikecustomtoggle = false,
		mortalstrikecustom = "Type your custom Announce",
		slam = false,
		slamcustom = "SLAM SLAM SLAM SLAM SLAM",
		slamsound = "none",
		swordandboardsound = "none",
		swordandboard = false,
		swordandboardcustom = "SHIELD SLAM SHIELD SLAM SHIELD SLAM",
		slaughtersound = "none",
		slaughter = false,
		slaughtercustom = "Slaughter Slaughter Slaughter",
		enragesound = "none",
		enrage = false,
		enragecustom = "Enrage Enrage Enrage",
		enragefaded = false,
		tasteforbloodsound = "none",
		tasteforblood = false,
		tasteforbloodcustom = "OVERPOWER OVERPOWER OVERPOWER",
		suddendeathsound = "none",
		suddendeath = false,
		suddendeathcustom = "Smash Smash Smash",
		challshoutused = false,
		challshoutfaded = false,
		challshoutfailed = false,
		challshoutcustom = "Type your custom Announce",
		challshoutcustomtoggle = false,
		tauntfailed = false,
		tauntcustom = "Type your custom Announce",
		intimidatingshoutfaded = false,
		intimidatingshoutfailed = false,
		intimidatingshoutcustomtoggle = false,
		intimidatingshoutcustom = "Type your custom Announce",
		piercinghowlcustomtoggle = false,
		piercinghowlcustom = "Type your custom Announce",
		piercinghowlfailed = false,
		piercinghowlfaded = false,
		deathwishcustomtoggle = false,
		deathwishcustom = "Type your custom Announce",
		deathwishfaded = false,
		recklessnesscustomtoggle = false,
		recklessnesscustom = "Type your custom Announce",
		recklessnessfaded = false,
		enragedregenerationcustomtoggle = false,
		enragedregenerationcustom = "Type your custom Announce",
		enragedregenerationfaded = false,
		shieldwallused = false,
		shieldwallfaded = false,
		shieldwallcustomtoggle = false,
		shieldwallcustom = "Type your custom Announce",
		laststandfaded = false,
		laststandused = false,
		laststandcustomtoggle = false,
		laststandcustom = "Type your custom Announce",
		disarmused = false,
		disarmfaded = false,
		disarmfailed = false,
		disarmcustom = "Type your custom Announce",
		vigilancefaded = false,
		vigilanceannounced = false,
		vigilancesound = "none",
		vigilancecustom = "Type your custom Announce",
		shatteringthrowannounce = false,
		shatteringthrowfade = false,
		shatteringthrowcustom = "Type your custom Announce",
		shatteringthrowcustomtoggle = false,
		retaliationcustomtoggle = false,
		retaliationcustom = "Type your custom Announce",
		retaliationfaded = false,
		hamstringused = false,
		hamstringfaded = false,
		hamstringfailed = false,
		hamstringcustom = "Type your custom Announce",
		shieldbashsuccessfulinterrupt = false,
		shieldbashcustom = "Type your custom Announce",
		shieldbashfailed = false,
		pummelsuccessfulinterrupt = false,
		pummelcustom = "Type your custom Announce",
		pummelfailed = false,
		tauntmonitortoggle = false,
		ccmonitotoggle = false,
		flaskexpired = false,
		flaskexpiredsound = "none",
		flaskexpiredcustom = "ALERT Flask Expired ALERT",
		foodexpired = false,
		foodexpiredsound = "none",
		foodexpiredcustom = "ALERT Food Buff Expired ALERT",
		imdeadcustom = "I'm Dead I'm Dead I'm Dead",
		imdead = false,
		AutoResbat = false,
		AutoAccRes = false,
		sunderarmor = false,
		ladestormcustomtoggle = false,
		bladestormcustom = "Type your custom Announce",
		bladestormfaded = false,
		deadlycalmcustom = "Type your custom Announce",
		deadlycalmfaded = false,
		sct = "none",
		uierrorframetext = false,
		nwasct = false,
		lock = false,
		font = "Friz Quadrata TT",
		fontsize = 20,
		fontoutline = "OUTLINE",
			["sctfc"] = {
					["colour"] = {
						["r"] = 0,
						["g"] = 1,
						["b"] = 0,
								},

			},
			["sctframe"] = {
					["posistion"] = {
					["y"] = 0,
					["rp"] = "CENTER",
					["p"] = "CENTER",
					["x"] = 0,
					}
					},
    },
}
--Initialize function--
function NuttyWarAnnounce:OnInitialize()
if select(2,UnitClass("player")) == "WARRIOR" then
    print("|cffFF0000Nutty War Announce:|r |cff00FF00Enabled|r")
	    elseif not Warrior then
    print("|cffFF0000Nutty War Announce:|r |cff00FF00Not a warrior. Disabling addon for next login|r")
      DisableAddOn("NuttyWarAnnounce")
      enabled = false
end
	NuttyWarAnnounce.db = LibStub("AceDB-3.0"):New("NuttyWarAnnounceDB", defaults, "Default")
	NuttyWarAnnounce:setupOptions()

end

--resisters events--
function NuttyWarAnnounce:OnEnable()
NuttyWarAnnounce:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
NuttyWarAnnounce:RegisterEvent("PLAYER_DEAD");
NuttyWarAnnounce:RegisterEvent("RESURRECT_REQUEST");
NuttyWarAnnounce:RegisterEvent("UNIT_AURA");
end
------locals all aoe spells have own spam prevention timer to prevent them clashing----
local demofrequency = 5
local demolastAnnounce = time()
local thunderclapfrequency = 5
local thunderclaplastAnnounce = time()
local intimishoutfrequency = 5
local intimishoutlastAnnounce = time()
local pierhowlfrequency = 5
local pierhowllastAnnounce = time()
local chalfrequency = 5
local challastAnnounce = time()
local WhoTauntedfrequency = 0.1
local WhoTauntedlastAnnounce = time()
local ccbreakfrequency = 2
local ccbreaklastAnnounce = time()
local rendfrequency = 5
local rendlastAnnounce = time()
local sundercount = 0
local msone = "%s"
local mstwo = "%s %s"
local msthree = "%s %s %s"
local msthreearrow = "%s %s >>%s<<"
local msfour = "%s %s %s %s"
local msfive = "%s %s %s %s %s"
local msfourarrow = "%s %s %s >>%s<<"
local msfivearrow = "%s %s %s >>%s<<, %s"
local mssix = "%s %s %s %s %s %s"
local msseven = "%s %s %s %s %s %s %s"
local bit_band = _G.bit.band
--Heart of the addon watches for events--	
function NuttyWarAnnounce:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, subevent, srcGUID, srcName, srcflags, dstGUID, dstName, dstflags, spellID, spellname, spellschool, missType, extraSpellName)
	if UnitGUID("player") == srcGUID then
		if subevent == "SPELL_AURA_APPLIED" then
		local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.chalshout[spellID] then			
				NuttyWarAnnounce:ChalShoutAnnounce(link)
				else if NuttyWarAnnounce.spellids.shieldwall[spellID] then
					NuttyWarAnnounce:SieldWallAnnounce(link)
					else if NuttyWarAnnounce.spellids.shatteringthrow[spellID] then
						NuttyWarAnnounce:ShatteringThrowAnnounce(dstName, link)
						else if NuttyWarAnnounce.spellids.laststand[spellID] then
							NuttyWarAnnounce:LastStandAnnounce(link)
							else if NuttyWarAnnounce.spellids.disarm[spellID] then
								NuttyWarAnnounce:DisarmAnnounce(dstName, link)
								else if NuttyWarAnnounce.spellids.instantslam[spellID] then
									NuttyWarAnnounce:InstantSlam(link)
									else if NuttyWarAnnounce.spellids.vigilance[spellID] then
										NuttyWarAnnounce:VigilanceAnnounce(dstName, link)
										else if NuttyWarAnnounce.spellids.deathwish[spellID] then 
											NuttyWarAnnounce:DeathWish(link)
											else if NuttyWarAnnounce.spellids.recklessness[spellID] then 
												NuttyWarAnnounce:Recklessness(link)
												else if NuttyWarAnnounce.spellids.retaliation[spellID] then 
													NuttyWarAnnounce:Retaliation(link)
													else if NuttyWarAnnounce.spellids.swordandbord[spellID] then
														NuttyWarAnnounce:SwordandBoard(link)
															else if NuttyWarAnnounce.spellids.tastforblood[spellID] then
																NuttyWarAnnounce:TasteforBlood(link)
																else if NuttyWarAnnounce.spellids.intimidatingshout[spellID] then
																	NuttyWarAnnounce:IntimidatingShoutAnnounce(link)
																	else if NuttyWarAnnounce.spellids.piercinghowl[spellID] then
																		NuttyWarAnnounce:PiercingHowlAnnounce(link)
																		else if NuttyWarAnnounce.spellids.suddendeath[spellID] then
																			NuttyWarAnnounce:SuddenDeath(link)
																			else if NuttyWarAnnounce.spellids.hamstring[spellID] then
																				NuttyWarAnnounce:HamstringAnnounce(dstName, link)
																				else if NuttyWarAnnounce.spellids.bladestorm[spellID] then			
																					NuttyWarAnnounce:bladestorm(link)
																					else if NuttyWarAnnounce.spellids.deadlycalm[spellID] then			
																						NuttyWarAnnounce:deadlycalm(link)
																						else if NuttyWarAnnounce.spellids.slaughter[spellID] then
																							NuttyWarAnnounce:Slaughter(link)
																							else if NuttyWarAnnounce.spellids.enragedregeneration[spellID] then 
																								NuttyWarAnnounce:EnragedRegeneration(link)
																								else if NuttyWarAnnounce.spellids.enrage[spellID] then 
																									NuttyWarAnnounce:Enrage(link)
																								end
																							end
																						end
																					end
																				end
																			end
																		end
																	end
																end
															end
														end
													end
												end
											end
										end
									end
								end
							end 
						end
					end
				end
			end
		if subevent == "SPELL_AURA_REMOVED" then
		local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.chalshout[spellID] then
				NuttyWarAnnounce:ChalShoutFaded(link)
				else if NuttyWarAnnounce.spellids.BattleShout[spellID] then
					NuttyWarAnnounce:BattleShoutAnnounce(srcName, dstName, link)
					else if NuttyWarAnnounce.spellids.CommandingShout[spellID] then
						NuttyWarAnnounce:CommandingShoutAnnounce(srcName, dstName, link)
						else if NuttyWarAnnounce.spellids.shieldwall[spellID] then
							NuttyWarAnnounce:ShieldWallFade(link)
							else if NuttyWarAnnounce.spellids.shatteringthrow[spellID] then
								NuttyWarAnnounce:ShatteringThrowFaded(dstName, link)
								else if NuttyWarAnnounce.spellids.laststand[spellID] then
									NuttyWarAnnounce:LastStandFade(link)
									else if NuttyWarAnnounce.spellids.disarm[spellID] then
										NuttyWarAnnounce:DisarmFaded(dstName, link)
										else if NuttyWarAnnounce.spellids.vigilance[spellID] then
											NuttyWarAnnounce:VigilanceFaded(dstName, link)
											else if NuttyWarAnnounce.spellids.deathwish[spellID] then
												NuttyWarAnnounce:DeathWishFaded(link)
												else if NuttyWarAnnounce.spellids.recklessness[spellID] then
													NuttyWarAnnounce:RecklessnessFaded(link)
													else if NuttyWarAnnounce.spellids.retaliation[spellID] then 
														NuttyWarAnnounce:RetaliationFaded(link)
														else if NuttyWarAnnounce.spellids.demoshout[spellID] then
															NuttyWarAnnounce:Demoshout(link)
															else if NuttyWarAnnounce.spellids.thunderclap[spellID] then
																NuttyWarAnnounce:Thunderclap(link)
																else if NuttyWarAnnounce.spellids.intimidatingshout[spellID] then
																	NuttyWarAnnounce:IntimidatingShoutFaded(link)
																	else if NuttyWarAnnounce.spellids.piercinghowl[spellID] then
																		NuttyWarAnnounce:PiercingHowlFaded(link)
																		else if NuttyWarAnnounce.spellids.mortalstrike[spellID] then
																			NuttyWarAnnounce:MortalStrike(dstName, link)
																			else if NuttyWarAnnounce.spellids.rend[spellID] then
																				NuttyWarAnnounce:Rend(dstName, link)
																				else if NuttyWarAnnounce.spellids.hamstring[spellID] then
																					NuttyWarAnnounce:HamstringFaded(dstName, link)
																					else if NuttyWarAnnounce.spellids.flask[spellID] then
																						NuttyWarAnnounce:FlaskExpired(link)
																						else if NuttyWarAnnounce.spellids.food[spellID] then
																							NuttyWarAnnounce:FoodExpired(link)
																							else if NuttyWarAnnounce.spellids.bladestorm[spellID] then 
																								NuttyWarAnnounce:bladestormFaded(link)
																								else if NuttyWarAnnounce.spellids.deadlycalm[spellID] then 
																									NuttyWarAnnounce:deadlycalmFaded(link)
																									else if NuttyWarAnnounce.spellids.enragedregeneration[spellID] then 
																										NuttyWarAnnounce:EnragedRegenerationFaded(link)
																										else if NuttyWarAnnounce.spellids.enrage[spellID] then 
																											NuttyWarAnnounce:EnrageFaded(link)
																										end
																									end
																								end
																							end
																						end
																					end
																				end
																			end
																		end
																	end
																end	
															end
														end
													end
												end
											end
										end
									end
								end									
							end
						end
					end
				end
			end
		end	
		if subevent == "SPELL_MISSED" then
		local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.chalshout[spellID] then
				NuttyWarAnnounce:ChalShoutFailed(missType, link)
				else if NuttyWarAnnounce.spellids.taunt[spellID] then
					NuttyWarAnnounce:TauntFailedAnnounce(missType, dstName, link)
						else if NuttyWarAnnounce.spellids.disarm[spellID] then
							NuttyWarAnnounce:DisarmFailed(missType, dstName, link)
							else if NuttyWarAnnounce.spellids.shieldbash[spellID] then
								NuttyWarAnnounce:ShieldBashMissed(missType, dstName, link)
								else if NuttyWarAnnounce.spellids.pummel[spellID] then
									NuttyWarAnnounce:PummelMissed(dstName, link)
									else if NuttyWarAnnounce.spellids.intimidatingshout[spellID] then
										NuttyWarAnnounce:IntimidatingShoutFailed(missType, link)
										else if NuttyWarAnnounce.spellids.piercinghowl[spellID] then
											NuttyWarAnnounce:PiercingHowlFailed(missType, link)
											else if NuttyWarAnnounce.spellids.hamstring[spellID] then
												NuttyWarAnnounce:HamstringFailed(missType, dstName, link)
											end
										end	
									end
								end
							end
						end
					end
				end
			end
		if subevent == "SPELL_INTERRUPT" then
		local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.pummel[spellID] then
				NuttyWarAnnounce:InterruptPummel(extraSpellName, dstName, link)
				else if NuttyWarAnnounce.spellids.shieldbash[spellID] then
					NuttyWarAnnounce:InterruptShieldBash(extraSpellName, dstName, link)
				end
			end
		end
		if subevent == "SPELL_CAST_SUCCESS" then
			local link = GetSpellLink(spellID)
				if NuttyWarAnnounce.spellids.BattleShout[spellID] then
					NuttyWarAnnounce:BattleShoutAnnounceAll(srcName, dstName, link)
					else if NuttyWarAnnounce.spellids.CommandingShout[spellID] then
						NuttyWarAnnounce:CommandingShoutAnnounceAll(srcName, dstName, link)
					end
				end
			end
		end
	-------NOT FILETERED SO CAN SEE OTHER PEOPLES TAUNTS--------
		if subevent == "SPELL_CAST_SUCCESS" then
			local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.singletaunts[spellID] then
				NuttyWarAnnounce:singletaunts(srcName, dstName, link)
			end
		end
		if subevent == "SPELL_AURA_APPLIED" then
			local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.aoetaunts[spellID] then
				NuttyWarAnnounce:aoetaunts(srcName, dstName, link)
			end
		end
		if subevent == "SPELL_AURA_BROKEN_SPELL" and bit_band(dstflags, COMBATLOG_OBJECT_REACTION_HOSTILE) == COMBATLOG_OBJECT_REACTION_HOSTILE then 
			local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.ccbroken[spellID] then
				NuttyWarAnnounce:ccbrokenspell(link,dstName,srcName,extraSpellName)
			end
		end
		if subevent == "SPELL_AURA_REMOVED" and bit_band(dstflags, COMBATLOG_OBJECT_REACTION_HOSTILE) == COMBATLOG_OBJECT_REACTION_HOSTILE then 
		local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.ccbroken[spellID] then
				NuttyWarAnnounce:ccbrokenfade(link,dstName)
			end
		end
		if subevent == "SPELL_AURA_BROKEN" and bit_band(dstflags, COMBATLOG_OBJECT_REACTION_HOSTILE) == COMBATLOG_OBJECT_REACTION_HOSTILE then 
		local link = GetSpellLink(spellID)
			if NuttyWarAnnounce.spellids.ccbroken[spellID] then
				NuttyWarAnnounce:ccbrokenmelee(link,dstName,srcName)
			end
		end
end
--fury abilities--
function NuttyWarAnnounce:PiercingHowlAnnounce(link)
	if ((pierhowllastAnnounce + pierhowlfrequency) < time()) then
			pierhowllastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputused(link)
		if NuttyWarAnnounce.db.profile.piercinghowlcustomtoggle then
		local custom = NuttyWarAnnounce.db.profile.piercinghowlcustom
			message = format(msthree,link,"Used", custom)
			NuttyWarAnnounce:Announce(message)
		 end
	 end
 end
function NuttyWarAnnounce:PiercingHowlFaded(link)
	if ((pierhowllastAnnounce + pierhowlfrequency) < time()) then
			pierhowllastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputfaded(link)
		if NuttyWarAnnounce.db.profile.piercinghowlfaded then
			message = format(mstwo, link,"Faded")
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:PiercingHowlFailed(missType, link)
	if ((pierhowllastAnnounce + pierhowlfrequency) < time()) then
			pierhowllastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputfailed(link)
		if NuttyWarAnnounce.db.profile.piercinghowlfailed then
			message = format(msthreearrow, link,"Failed", missType)
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:IntimidatingShoutAnnounce(link)
	if ((intimishoutlastAnnounce + intimishoutfrequency) < time()) then
			intimishoutlastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputused(link)
		if NuttyWarAnnounce.db.profile.intimidatingshoutcustomtoggle then
		local custom = NuttyWarAnnounce.db.profile.intimidatingshoutcustom
			message = format(msthree,link,"Used", custom)
			NuttyWarAnnounce:Announce(message)
		 end
	 end
 end
function NuttyWarAnnounce:IntimidatingShoutFaded(link)
	if ((intimishoutlastAnnounce + intimishoutfrequency) < time()) then
			intimishoutlastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputfaded(link)
		if NuttyWarAnnounce.db.profile.intimidatingshoutfaded then
			message = format(mstwo, link,"Faded")
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:IntimidatingShoutFailed(missType, link)
	if ((intimishoutlastAnnounce + intimishoutfrequency) < time()) then
		intimishoutlastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputfailed(link)
		if NuttyWarAnnounce.db.profile.intimidatingshoutfailed then
			message = format(msthreearrow, link,"Failed", missType)
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:Recklessness(link)
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.recklessnesscustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.recklessnesscustom
		message = format(msthree, link,"Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:RecklessnessFaded(link)
	NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.recklessnessfaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:DeathWish(link)
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.deathwishcustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.deathwishcustom
		message = format(msthree, link,"Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:DeathWishFaded(link)
	NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.deathwishfaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end
--prot abilities--
function NuttyWarAnnounce:DisarmAnnounce(dstName, link)
	NuttyWarAnnounce:nwasctoutputusedon(link,dstName)
	if NuttyWarAnnounce.db.profile.disarmused then
	local custom = NuttyWarAnnounce.db.profile.disarmcustom
		message = format(msfour, link,"Used on:", dstName, custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:DisarmFaded(dstName, link)
	NuttyWarAnnounce:nwasctoutputfadedon(link,dstName)
	if NuttyWarAnnounce.db.profile.disarmfaded then
		message = format(msthree, link,"Faded on:", dstName)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:DisarmFailed(missType, dstName, link)
	NuttyWarAnnounce:nwasctoutputfailedon(link,dstName)
	if NuttyWarAnnounce.db.profile.disarmfailed then
		message = format(msfourarrow, link,"Failed on:", dstName, missType)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:LastStandAnnounce(link)
	NumSayLS = table.getn( NuttyWarAnnounce.sayings.LastStandSay );
	SNumLS = math.random( NumSayLS );
	LastStand_Say = NuttyWarAnnounce.sayings.LastStandSay[SNumLS];
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.laststandused then
		message = format(msthree, link,"Used:", LastStand_Say)
		NuttyWarAnnounce:Announce(message)
	elseif NuttyWarAnnounce.db.profile.laststandcustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.laststandcustom
		message = format(msthree, link,"Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:LastStandFade(link)
	NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.laststandfaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:SieldWallAnnounce(link)
	NumSaySW = table.getn( NuttyWarAnnounce.sayings.ShieldWallSay );
	SNumSW = math.random( NumSaySW );
	ShieldWall_Say = NuttyWarAnnounce.sayings.ShieldWallSay[SNumSW];
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.shieldwallused then
		message = format(msthree, link,"Used:", ShieldWall_Say)
		NuttyWarAnnounce:Announce(message)
	elseif NuttyWarAnnounce.db.profile.shieldwallcustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.shieldwallcustom
		message = format(msthree,link,"Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:ShieldWallFade(link)
	NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.shieldwallfaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:VigilanceAnnounce(dstName, link)
	NuttyWarAnnounce:nwasctoutputusedon(link,dstName)
	if NuttyWarAnnounce.db.profile.vigilanceannounced then
	local custom = NuttyWarAnnounce.db.profile.vigilancecustom
		message = format(msfour, link,"Used on:", dstName, custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:VigilanceFaded(dstName, link)
	NuttyWarAnnounce:nwasctoutputfadedon(link,dstName)
	if NuttyWarAnnounce.db.profile.vigilancefaded then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.vigilancesound]
  		NuttyWarAnnounce:Playsoundfile(soundFile)
		print(link,"|cffFF0000Faded on:|r", dstName,"|cffFF0000Recast|r")
	end
end
function NuttyWarAnnounce:EnragedRegeneration(link)
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.enragedregenerationcustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.enragedregenerationcustom
		message = format(msthree, link,"Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:EnragedRegenerationFaded(link)
	NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.enragedregenerationfaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end

--arms abilities--
function NuttyWarAnnounce:HamstringAnnounce(dstName, link)
	NuttyWarAnnounce:nwasctoutputusedon(link,dstName)
	if NuttyWarAnnounce.db.profile.hamstringused then
	local custom = NuttyWarAnnounce.db.profile.hamstringcustom
		message = format(msfour, link,"Used on:", dstName, custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:HamstringFaded(dstName, link)
	NuttyWarAnnounce:nwasctoutputfadedon(link,dstName)
	if NuttyWarAnnounce.db.profile.hamstringfaded then
		message = format(msthree, link,"Faded on:", dstName)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:HamstringFailed(missType, dstName, link)
	NuttyWarAnnounce:nwasctoutputfailedon(link,dstName)
	if NuttyWarAnnounce.db.profile.hamstringfailed then
		message = format(msfourarrow, link,"Failed on:", dstName, missType)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:Retaliation(link)
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.retaliationcustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.retaliationcustom
		message = format(msthree, link,"Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:RetaliationFaded(link)
	NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.retaliationfaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:ShatteringThrowAnnounce(dstName, link)
	NumSayST = table.getn( NuttyWarAnnounce.sayings.ShattThrowSay );
	SNumST = math.random( NumSayST );
	ShattThrow_Say = NuttyWarAnnounce.sayings.ShattThrowSay[SNumST];
	NuttyWarAnnounce:nwasctoutputusedon(link,dstName)
	if NuttyWarAnnounce.db.profile.shatteringthrowannounce then
		message = format(msfour, link,"Used on:", dstName, ShattThrow_Say)
		NuttyWarAnnounce:Announce(message)
	elseif NuttyWarAnnounce.db.profile.shatteringthrowcustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.shatteringthrowcustom
		message = format(msfour,link,"Used on:", dstName, custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:ShatteringThrowFaded(dstName, link)
	NuttyWarAnnounce:nwasctoutputfadedon(link,dstName)
	if NuttyWarAnnounce.db.profile.shatteringthrowfade then
		message = format(msthree, link,"Faded on:", dstName)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:bladestorm(link)
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.bladestormcustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.bladestormcustom
		message = format(msthree, link,"Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:bladestormFaded(link)
	NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.bladestormfaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:deadlycalm(link)
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.deadlycalmcustomtoggle then
	local custom = NuttyWarAnnounce.db.profile.deadlycalmcustom
		message = format(msthree, link,"Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:deadlycalmFaded(link)
	NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.deadlycalmfaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end
--interrupts--
function NuttyWarAnnounce:PummelMissed(dstName, link)
	local cast = UnitCastingInfo('target')
	local chan = UnitChannelInfo('target')
	if cast or chan then
	NuttyWarAnnounce:nwasctoutputfailedinterruptedon(link,dstName)
		if NuttyWarAnnounce.db.profile.pummelfailed then
			message = format(msthree, link, "Failed to Interrupt:", dstName)
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:ShieldBashMissed(timestamp, dstName, link)
	local cast = UnitCastingInfo('target')
	local chan = UnitChannelInfo('target')
	if cast or chan then
	NuttyWarAnnounce:nwasctoutputfailedinterruptedon(link,dstName)
		if NuttyWarAnnounce.db.profile.shieldbashfailed then
			message = format(msthree, link, "Failed to Interrupt:", dstName)
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:InterruptShieldBash(extraSpellName, dstName, link)
	NuttyWarAnnounce:nwasctoutputinterruptedon(link,dstName)
	if NuttyWarAnnounce.db.profile.shieldbashsuccessfulinterrupt then
	local custom = NuttyWarAnnounce.db.profile.shieldbashcustom
		message = format(mssix, dstName, "'s", extraSpellName, "Interrupted with", link, custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:InterruptPummel(extraSpellName, dstName, link)
	NuttyWarAnnounce:nwasctoutputinterruptedon(link,dstName)
	if NuttyWarAnnounce.db.profile.pummelsuccessfulinterrupt then
	local custom = NuttyWarAnnounce.db.profile.pummelcustom
		message = format(mssix, dstName, "'s", extraSpellName, "Interrupted with", link, custom)
		NuttyWarAnnounce:Announce(message)
	end
end
--buffs--
function NuttyWarAnnounce:CommandingShoutAnnounce(srcName, dstname, link)
	if InCombatLockdown() and srcName == dstname then
		local sctmessage = ("ALERT COMMANDING SHOUT FADED RECAST ALERT")
		NuttyWarAnnounce:nwasctoutputbufffaded(link)
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		if NuttyWarAnnounce.db.profile.commandingshout then
		local custom = NuttyWarAnnounce.db.profile.commandingshoutcustom
			print(link,custom)
		end
		if NuttyWarAnnounce.db.profile.commandingshoutsound then
		local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.commandingshoutsound]
			NuttyWarAnnounce:Playsoundfile(soundFile)
		end
		if NuttyWarAnnounce.db.profile.commandingshoutfadedall then
			message = format(mstwo, link,"Faded")
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:BattleShoutAnnounce(srcName, dstname, link)
	if InCombatLockdown() and srcName == dstname then 
		local sctmessage = ("ALERT BATTLE SHOUT FADED RECAST ALERT")
		NuttyWarAnnounce:nwasctoutputbufffaded(link)
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		if NuttyWarAnnounce.db.profile.battleshout then
		local custom = NuttyWarAnnounce.db.profile.battleshoutcustom
			print(link,custom)
		end
		if NuttyWarAnnounce.db.profile.battleshoutsound then
		local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.battleshoutsound]
			NuttyWarAnnounce:Playsoundfile(soundFile)
		end
		if NuttyWarAnnounce.db.profile.battleshoutfadedall then
			message = format(mstwo, link,"Faded")
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:CommandingShoutAnnounceAll(srcName, dstName, link)
	local sctmessage = ("COMMANDING SHOUT USED")		
	NuttyWarAnnounce:Combattext(sctmessage)
	NuttyWarAnnounce:UIerrorstext(sctmessage)
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.commandingshoutall then
	local custom = NuttyWarAnnounce.db.profile.commandingshoutcustomall
		message = format(msthree, link, "Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:BattleShoutAnnounceAll(srcName, dstName, link)
	local sctmessage = ("BATTLE SHOUT USED")		
	NuttyWarAnnounce:Combattext(sctmessage)
	NuttyWarAnnounce:UIerrorstext(sctmessage)
	NuttyWarAnnounce:nwasctoutputused(link)
	if NuttyWarAnnounce.db.profile.battleshoutall then
	local custom = NuttyWarAnnounce.db.profile.battleshoutcustomall
		message = format(msthree, link, "Used", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
--expiries --
function NuttyWarAnnounce:Rend(dstName, link)
	if ((rendlastAnnounce + rendfrequency) < time()) then
			rendlastAnnounce = time()
	local sctmessage = ("ALERT REND EXPIRED ALERT")
		NuttyWarAnnounce:nwasctoutputfadedon(link,dstName)
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		if NuttyWarAnnounce.db.profile.rendcustomtoggle then
		local custom = NuttyWarAnnounce.db.profile.rendcustom
			message = format(msfour, link,"Faded on:", dstName, custom)
			NuttyWarAnnounce:Announce(message)
		end
		if NuttyWarAnnounce.db.profile.rendsound then
		local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.rendsound]
			NuttyWarAnnounce:Playsoundfile(soundFile)
		end
	end
end
function NuttyWarAnnounce:MortalStrike(dstName, link)
	local sctmessage = ("ALERT MORTAL STRIKE EXPIRED ALERT")
		NuttyWarAnnounce:nwasctoutputfadedon(link,dstName)
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		if NuttyWarAnnounce.db.profile.mortalstrikecustomtoggle then
		local custom = NuttyWarAnnounce.db.profile.mortalstrikecustom
			message = format(msfour, link,"Faded on:", dstName, custom)
			NuttyWarAnnounce:Announce(message)
		end
		if NuttyWarAnnounce.db.profile.mortalstrikesound then
		local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.mortalstrikesound]
			NuttyWarAnnounce:Playsoundfile(soundFile)
		end
	end
function NuttyWarAnnounce:Thunderclap(link)
	if ((thunderclaplastAnnounce + thunderclapfrequency) < time()) then
			thunderclaplastAnnounce = time()
	local sctmessage = ("ALERT THUNDERCLAP EXPIRED ALERT")	
		NuttyWarAnnounce:nwasctoutputfaded(link)
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		if NuttyWarAnnounce.db.profile.thunderclaptoggle then
		local custom = NuttyWarAnnounce.db.profile.thunderclapcustom
			print(link,custom)
		end
		if NuttyWarAnnounce.db.profile.thunderclapsound then
		local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.thunderclapsound]
			NuttyWarAnnounce:Playsoundfile(soundFile)
		end
	end
end
function NuttyWarAnnounce:Demoshout(link)
	if ((demolastAnnounce + demofrequency) < time()) then
			demolastAnnounce = time()
	local sctmessage = ("ALERT DEMORALIZING SHOUT EXPIRED ALERT")
		NuttyWarAnnounce:nwasctoutputfaded(link)
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		if NuttyWarAnnounce.db.profile.demo then
		local custom = NuttyWarAnnounce.db.profile.democustom
			print(link,custom)
		end
		if NuttyWarAnnounce.db.profile.demosound then
		local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.demosound]
			NuttyWarAnnounce:Playsoundfile(soundFile)
		end
	end
end
--procs--
function NuttyWarAnnounce:SuddenDeath(link)
	local sctmessage = ("Smash Smash Smash")
		NuttyWarAnnounce:nwasctoutputprocs(link)
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
	if NuttyWarAnnounce.db.profile.suddendeath then
	local custom = NuttyWarAnnounce.db.profile.suddendeathcustom
		print(link,custom)
	end
	if NuttyWarAnnounce.db.profile.suddendeathsound then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.suddendeathsound]
		NuttyWarAnnounce:Playsoundfile(soundFile)
	end
end
function NuttyWarAnnounce:InstantSlam(link)
	local sctmessage = ("SLAM SLAM SLAM SLAM SLAM")
		NuttyWarAnnounce:nwasctoutputprocs(link)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		NuttyWarAnnounce:Combattext(sctmessage)
	if NuttyWarAnnounce.db.profile.slam then
	local custom = NuttyWarAnnounce.db.profile.slamcustom
		print(link,custom)
	end
	if NuttyWarAnnounce.db.profile.slamsound then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.slamsound]
		NuttyWarAnnounce:Playsoundfile(soundFile)
	end
end
function NuttyWarAnnounce:TasteforBlood(link)
	local sctmessage = ("OVERPOWER OVERPOWER OVERPOWER")
		NuttyWarAnnounce:nwasctoutputprocs(link)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		NuttyWarAnnounce:Combattext(sctmessage)
	if NuttyWarAnnounce.db.profile.tasteforblood then
	local custom = NuttyWarAnnounce.db.profile.tasteforbloodcustom
		print(link,custom)
	end
	if NuttyWarAnnounce.db.profile.tasteforbloodsound then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.tasteforbloodsound]
		NuttyWarAnnounce:Playsoundfile(soundFile)
	end
end
function NuttyWarAnnounce:SwordandBoard(link)
	local sctmessage = ("SHIELD SLAM SHIELD SLAM SHIELD SLAM")
		NuttyWarAnnounce:nwasctoutputprocs(link)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		NuttyWarAnnounce:Combattext(sctmessage)
	if NuttyWarAnnounce.db.profile.swordandboard then
	local custom = NuttyWarAnnounce.db.profile.swordandboardcustom
		print(link,custom)
	end
	if NuttyWarAnnounce.db.profile.swordandboardsound then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.swordandboardsound]
		NuttyWarAnnounce:Playsoundfile(soundFile)
	end
end
function NuttyWarAnnounce:Slaughter(link)
	local sctmessage = ("Slaughter Slaughter Slaughter")
		NuttyWarAnnounce:nwasctoutputprocs(link)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		NuttyWarAnnounce:Combattext(sctmessage)
	if NuttyWarAnnounce.db.profile.slaughter then
	local custom = NuttyWarAnnounce.db.profile.slaughtercustom
		print(link,custom)
	end
	if NuttyWarAnnounce.db.profile.slaughtersound then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.slaughtersound]
		NuttyWarAnnounce:Playsoundfile(soundFile)
	end
end
function NuttyWarAnnounce:Enrage(link)
	local sctmessage = ("Enrage Enrage Enrage")
		NuttyWarAnnounce:nwasctoutputprocs(link)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		NuttyWarAnnounce:Combattext(sctmessage)
	if NuttyWarAnnounce.db.profile.enrage then
	local custom = NuttyWarAnnounce.db.profile.enragecustom
		print(link,custom)
	end
	if NuttyWarAnnounce.db.profile.enragesound then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.enragesound]
		NuttyWarAnnounce:Playsoundfile(soundFile)
	end
end
function NuttyWarAnnounce:EnrageFaded(link)
	local sctmessage = ("Enrage Faded Enrage Faded")
		NuttyWarAnnounce:nwasctoutputprocs(link)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:nwasctoutputfaded(link)
	if NuttyWarAnnounce.db.profile.enragefaded then
		message = format(mstwo, link,"Faded")
		NuttyWarAnnounce:Announce(message)
	end
end
--Taunts--
function NuttyWarAnnounce:ChalShoutAnnounce(link)
	NumSayCS = table.getn( NuttyWarAnnounce.sayings.ChallShoutSay );
	SNumCS = math.random( NumSayCS );
	ChallShout_Say = NuttyWarAnnounce.sayings.ChallShoutSay[SNumCS];
	if ((challastAnnounce + chalfrequency) < time()) then
			challastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputused(link)
		if NuttyWarAnnounce.db.profile.challshoutused then
			message = format(msthree, link,"Used:", ChallShout_Say)
			NuttyWarAnnounce:Announce(message)
		elseif NuttyWarAnnounce.db.profile.challshoutcustomtoggle then
		local custom = NuttyWarAnnounce.db.profile.challshoutcustom
			message = format(msthree,link,"Used", custom)
			NuttyWarAnnounce:Announce(message)
		 end
	 end
 end
function NuttyWarAnnounce:ChalShoutFaded(link)
	if ((challastAnnounce + chalfrequency) < time()) then
			challastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputfaded(link)
		if NuttyWarAnnounce.db.profile.challshoutfaded then
			message = format(mstwo, link,"Faded")
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:ChalShoutFailed(missType, link)
	if ((challastAnnounce + chalfrequency) < time()) then
			challastAnnounce = time()
		NuttyWarAnnounce:nwasctoutputfailed(link)
		if NuttyWarAnnounce.db.profile.challshoutfailed then
			message = format(msthreearrow, link,"Failed", missType)
			NuttyWarAnnounce:Announce(message)
		end
	end
end
function NuttyWarAnnounce:TauntFailedAnnounce(missType, dstName, link)
	NuttyWarAnnounce:nwasctoutputfailedon(link,dstName)
	if NuttyWarAnnounce.db.profile.tauntfailed then
	local custom = NuttyWarAnnounce.db.profile.tauntcustom
		message = format(msfivearrow, link,"Failed on:", dstName, missType, custom)
		NuttyWarAnnounce:Announce(message)
	end
end
--tools--
function NuttyWarAnnounce:ccbrokenspell(link,dstName,srcName,extraSpellName) 
if GetRealNumRaidMembers() > 0 or GetRealNumPartyMembers() > 0 then
	if NuttyWarAnnounce.db.profile.ccmonitortoggle then
		if ((ccbreaklastAnnounce + ccbreakfrequency) < time()) then 
			ccbreaklastAnnounce = time()
			message = format(msseven, srcName, "Broke", dstName,"'s", link, "with", extraSpellName)
			NuttyWarAnnounce:Announce(message)
		end
	end
end
end
function NuttyWarAnnounce:ccbrokenmelee(link,dstName,srcName) 
if GetRealNumRaidMembers() > 0 or GetRealNumPartyMembers() > 0 then
	if NuttyWarAnnounce.db.profile.ccmonitortoggle then
		if ((ccbreaklastAnnounce + ccbreakfrequency) < time()) then 
			ccbreaklastAnnounce = time()
			message = format(msfive, srcName, "removed", link, "on", dstName)
			NuttyWarAnnounce:Announce(message)
		end
	end
end
end
function NuttyWarAnnounce:ccbrokenfade(link,dstName) 
if GetRealNumRaidMembers() > 0 or GetRealNumPartyMembers() > 0 then
	if NuttyWarAnnounce.db.profile.ccmonitortoggle then
		if ((ccbreaklastAnnounce + ccbreakfrequency) < time()) then 
			ccbreaklastAnnounce = time()
		
			message = format(msthree, dstName, "Broke", link)
			NuttyWarAnnounce:Announce(message)
		end
	end
end
end
function NuttyWarAnnounce:PLAYER_DEAD()
	NuttyWarAnnounce:ImDeadAnnounce()
	NuttyWarAnnounce:BattlfieldRes()
end
function NuttyWarAnnounce:ImDeadAnnounce()
	if NuttyWarAnnounce.db.profile.imdead then
	local custom = NuttyWarAnnounce.db.profile.imdeadcustom
		message = format(mstwo,"I'm Dead", custom)
		NuttyWarAnnounce:Announce(message)
	end
end
function NuttyWarAnnounce:BattlfieldRes()
if (MiniMapBattlefieldFrame.status == "active" or Zone == "Wintergrasp") then
	if NuttyWarAnnounce.db.profile.AutoResbat then
		local Zone = GetRealZoneText()
		RepopMe()
		end
	end
end
function NuttyWarAnnounce:RESURRECT_REQUEST(event,player)
if NuttyWarAnnounce.db.profile.AutoAccRes then
	if (UnitAffectingCombat("player") == nil and GetCorpseRecoveryDelay() == 0) then
			local msg = "Thanks for the Rez :)."
			SendChatMessage(msg, "WHISPER", nil , player);
			AcceptResurrect()
		else
			local msg = "Thanks for the Rez! I still have a "..GetCorpseRecoveryDelay().." seconds delay until I can accept it."
			SendChatMessage(msg, "WHISPER", nil , player);
		end
	end
end
function NuttyWarAnnounce:FoodExpired(link)
	if NuttyWarAnnounce.db.profile.foodexpired then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.foodexpiredsound]
	local custom = NuttyWarAnnounce.db.profile.foodexpiredcustom
	local sctmessage = ("ALERT Food Buff Expired ALERT")
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		NuttyWarAnnounce:Playsoundfile(soundFile)
		print(link, custom)
end
end
function NuttyWarAnnounce:FlaskExpired(link)
	if NuttyWarAnnounce.db.profile.flaskexpired then
	local soundFile = NuttyWarAnnounce.SoundFiles[NuttyWarAnnounce.db.profile.flaskexpiredsound]
	local custom = NuttyWarAnnounce.db.profile.flaskexpiredcustom
	local sctmessage = ("ALERT Flask Expired ALERT")
		NuttyWarAnnounce:Combattext(sctmessage)
		NuttyWarAnnounce:UIerrorstext(sctmessage)
		NuttyWarAnnounce:Playsoundfile(soundFile)
		print(link, custom)
	end
end
function NuttyWarAnnounce:singletaunts(srcName, dstName, link)
	if GetRealNumRaidMembers() > 0 or GetRealNumPartyMembers() > 0 then
		if NuttyWarAnnounce.db.profile.tauntmonitortoggle then
			print(srcName, "Taunted with", link, "on", dstName)
		end
	end
end
function NuttyWarAnnounce:aoetaunts(srcName, dstName, link)
	if GetRealNumRaidMembers() > 0 or GetRealNumPartyMembers() > 0 then
		if NuttyWarAnnounce.db.profile.tauntmonitortoggle then
			if ((WhoTauntedlastAnnounce + WhoTauntedfrequency) < time()) then
				WhoTauntedlastAnnounce = time()
				print(srcName, "AOE Taunted with", link)
			end
		end
	end
end
function NuttyWarAnnounce:UNIT_AURA()
local oldcount = 0
local targetName = UnitName("target");
	name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitDebuff("target", "Sunder Armor")
	if name == "Sunder Armor" and NuttyWarAnnounce.db.profile.sunderarmor then
		oldcount = sundercount
		sundercount = count
		if oldcount ~= sundercount and sundercount == 3 then
			local link = GetSpellLink(spellId)
				message = format(msthree, link,"Is now stacked 3 times on", targetName)
				NuttyWarAnnounce:Announce(message)
		end
	end
end
--chat--
function NuttyWarAnnounce:Announce(message)
		NuttyWarAnnounce:party(message) 
		NuttyWarAnnounce:say(message) 
		NuttyWarAnnounce:yell(message)
		NuttyWarAnnounce:raid(message)
		NuttyWarAnnounce:raidwarning(message)
		NuttyWarAnnounce:whisper(message)
		NuttyWarAnnounce:customchan(message)
		NuttyWarAnnounce:nuttychatchan(message)
     end
function NuttyWarAnnounce:party(message)
	if NuttyWarAnnounce.db.profile.partyannounce and GetRealNumPartyMembers() > 0 then
	SendChatMessage(message, "PARTY")
	end
end
function NuttyWarAnnounce:say(message)
	if NuttyWarAnnounce.db.profile.sayannounce then
	SendChatMessage(message, "SAY")
	end
end
function NuttyWarAnnounce:yell(message)
	if NuttyWarAnnounce.db.profile.yellannounce then
	SendChatMessage(message, "YELL")
	end
end
function NuttyWarAnnounce:raid(message)
	if NuttyWarAnnounce.db.profile.raidannounce and GetRealNumRaidMembers() > 0 then
	SendChatMessage(message, "RAID")
	end
end
function NuttyWarAnnounce:raidwarning(message)
	if NuttyWarAnnounce.db.profile.raidwarningannounce and GetRealNumRaidMembers() > 0 then
	if (IsRaidLeader()) or (IsRaidOfficer()) then
	SendChatMessage(message, "RAID_WARNING")
		end
	end
end
function NuttyWarAnnounce:whisper(message)
	if NuttyWarAnnounce.db.profile.whisperannounce then
	local name = NuttyWarAnnounce.db.profile.whispercustom
		if (UnitName(name) ~= nil) then
		SendChatMessage(message, "WHISPER", nil, name)
		end
	end
end
function NuttyWarAnnounce:customchan(message)
	if NuttyWarAnnounce.db.profile.customchanannounce then
	local name = GetChannelName(NuttyWarAnnounce.db.profile.customchancustom)
		if (name ~= nil) then
		SendChatMessage(message, "CHANNEL", nil, name)
		end
	end
end
function NuttyWarAnnounce:nuttychatchan(message)
	if NuttyWarAnnounce.db.profile.nuttychatchanannounce then
		print(message)
		end
end
function NuttyWarAnnounce:Combattext(sctmessage)
	if( NuttyWarAnnounce.db.profile.sct == "Blizzard" and tostring(SHOW_COMBAT_TEXT) ~= "0" ) then
		CombatText_AddMessage( sctmessage, COMBAT_TEXT_SCROLL_FUNCTION, 0, 1, 0, nill, nill);
	elseif( NuttyWarAnnounce.db.profile.sct == "Parrot" and Parrot ) then
		Parrot:ShowMessage( sctmessage, "Outgoing", bSticky, 0, 1, 0, nil, fs, nil, strTex );
	elseif( NuttyWarAnnounce.db.profile.sct == "MSBT" and MikSBT and MikSBT.IsModDisabled() == nil ) then
		MikSBT.DisplayMessage( sctmessage, MikSBT.DISPLAYTYPE_OUTGOING, bSticky, nil, nil, nil, fs, nil, fo, strTex );
	end
end
function NuttyWarAnnounce:UIerrorstext(sctmessage)
	if NuttyWarAnnounce.db.profile.uierrorframetext then
		UIErrorsFrame:AddMessage(sctmessage, 0,1,0)
	end
end
function NuttyWarAnnounce:Playsoundfile(soundFile)
	if soundFile then
		PlaySoundFile(soundFile)
	end
end
--Tabels--
NuttyWarAnnounce.spellids = {
	BattleShout = {
				[6673] = "Battle Shout",
			},
	CommandingShout = {
				[469] = "Commanding Shout",
			},
	shieldwall = {
				[871] = "Shied Wall",				
			},
	laststand = {
				[12976] = "Last Stand",
			},
	shatteringthrow = {
				[64382] = "Shattering Throw",
			},				
	chalshout = {
				[1161] = "Challenging Shout",
			},
	disarm = {
				[676] = "Disarm",
			},
	taunt = {
				[355] = "Taunt",
			},
	instantslam = {
				[46916] = "Bloodsurge Rank1",
			},
	vigilance = {
				[50720] = "Vigilance",
				},
	pummel = {
				[6552] = "Pummel",
			},
	shieldbash = {
				[72] = "Shield Bash",
			},
	deathwish = {
				[12292] = "Death Wish",
			},
	recklessness = {
				[1719] = "Recklessness",
		},
	retaliation = {
				[20230] = "retaliation",
		},
	singletaunts = {
				[355] = "Taunt",
				[49576] = "Death Grip",
				[56222] = "Dark Command",
				[62124] = "Hand of Reckoning",
				[6795] = "Growl",
				[20736] = "Distracting Shot",
		},
	aoetaunts ={
				[1161] = "Challenging Shout",
				[31789] = "Righteous Defense",
				[5209] = "Challenging Roar",
				[59671] = "Challenging Howl",
		},
	swordandbord ={
				[50227] = "Sword and Board",
		},
	bladestorm ={
			[46924] = "Bladestorm",
		},
	demoshout ={
				[1160] = "Demoralizing Shout",
		},
	thunderclap ={
				[6343] = "Thunderclap",
		},
	tastforblood ={
				[60503] = "Taste for Blood",
		},
	mortalstrike ={
				[12294] = "Mortal Strike",
		},
	slaughter ={
				[84586] = "Slaughter",
				[84585] = "Slaughter",
				[84584] = "Slaughter",
			},
	rend ={
				[94009] = "Rend",
		},
	hamstring ={
				[1715] = "Hamstring",
		},
	piercinghowl ={
				[12323] = "Piercing Howl",
		},
	intimidatingshout ={
				[5246] = "Intimidating Shout",
		},
	suddendeath ={
				[52437] = "Sudden Death",
		},
	deadlycalm = {
				[85730] = "Deadly Calm",
		},
	enragedregeneration = {
				[55694] = "Enraged Regeneration",
		},
	food ={
				[57367] = "Well Fed Blackened Dragonfin",
				[57325] = "Well Fed Mega Mammoth Meal",
				[57399] = "Well Fed Fish Feast",
				[57371] = "Well Fed Dragonfin Filet",
				[57356] = "Well Fed Rhinolicious Wormsteak",
				[57360] = "Well Fed Snapper Extreme",
				[57358] = "Well Fed Hearty Rhino",
				[57329] = "Well Fed Spicy Blue Nettlefish",
				[57325] = "Well Fed Poached Northern Sculpin",
		},
	flask ={
				[53758] = "Flask of Stoneblood",
				[28520] = "Flask of Relentless Assault",
				[53760] = "Flask of Endless Rage",
		},
	ccbroken ={
				[118] = "Poly", 
				[12824] = "Poly", 
				[12825] = "Poly", 
				[61305] = "Poly", 
				[28272] = "Poly", 
				[61721] = "Poly", 
				[12826] = "Poly", 
				[61025] = "Poly", 
				[61780] = "Poly", 
				[28271] = "Poly", 
				[9484] = "Shackle", 
				[9485] = "Shackle",
				[10955] = "Shackle",
				[2637] = "Hibernate",
				[18657]= "Hibernate",
				[18658]= "Hibernate",
				[3355]= "Freezing trap", 
				[14308]= "Freezing trap", 
				[14309] = "Freezing trap",
				[60210] = "Freezing Arrow",
				[6770] = "Sap", 
				[2070] = "Sap", 
				[11297] = "Sap",
				[51724] = "Sap", 
				[20066] = "Repentance",
				[5782] = "Fear", 
				[6213] = "Fear", 
				[6215] = "Fear",
				[2094] = "Blind", 
				[51514] = "Hex",
				[19386] = "Wyvern Sting", 
				[24132] = "Wyvern Sting",
				[24133]= "Wyvern Sting",
				[27068]= "Wyvern Sting",
				[49011]= "Wyvern Sting", 
				[49012] = "Wyvern Sting",
				[6358] = "Seduction",
	},
	enrage ={
				[12880] = "Enrage",
				[14201] = "Enrage",
				[14202] = "Enrage",
	},
}		
NuttyWarAnnounce.sayings = {
	ChallShoutSay = {
	"All mobs on me for 6 seconds",
	"Mobs will find me irresistible for 6 seconds",
	"Let's have an orgy for 6 seconds",
	"Come to papa for 6 seconds",
	"Need some extra healing for 6 seconds",
},
    ShieldWallSay = {
	"Women might be able to fake orgasms. But men can fake a whole relationship.",
	"We live in a society where pizza gets to your house before the police.",
	"If I agreed with you we'd both be wrong.",
	"Light travels faster than sound. This is why some people appear bright until you hear them speak.",
	"We never really grow up, we only learn how to act in public.",
	"Having sex is like playing bridge. If you don't have a good partner, you'd better have a good hand.",
	"Politicians and diapers have one thing in common. They should both be changed regularly, and for the same reason.",
	"My mother never saw the irony in calling me a son-of-a-bitch.",
	"afk need bio brb",
	"What's the worst thing about playing a Paladin? Having to tell your parents that you're gay",
	"How many gnomes does it take to paint your wall? It depends on how hard you throw them",
	"You know your addicted to WoW when your girlfriends pants have a low drop rate!",
	"Your momma's so fat the Mages have to grease their portals and summon cinnamon rolls at the other side to get her through.",
	"Paladin dps is like a woman's orgasm, most people belive it to be a myth, few men can do it, even fewer can do it well, and most of the videos on the internet are fake.",
	"You know you play to much WoW when your microwave goes ding and you say Gratz",
	"What does a guy and a car have in common? They both have the ability to misfire.",
	"Why do men get their great ideas in bed? Because their plugged into a genius!",
	"Whats the difference between a wife and a girlfriend ? 3 Stone ! ",
	"Spank me spank me spank me",
	"I would love to change the world, but they won't give me the source code.",
	"If at first you don't succeed, call it version 1.0",
	"How are rogues and newbies alike? Both pick locks.",
	"Why do gnomes laugh while they run? The Grass tickles their balls.",
	"Statistically 1 in 7 dwarfs are grumpy",
	"AAAAH THE MOB IS TOUCHING ME GET IT OFF GET IT OFF GET IT OFF!",
	"YOU NO TAKE CANDLE!",
	"Cover for me! I gotto wizz behind a tree...",
},
	ShattThrowSay = {
	"Nuke Nuke Nuke",
	"You got 10seconds to make a difference",
	"Lets rock",
	"Full nuke go go go",
	"Spank it Spank it Spank it",
},
	LastStandSay = {
	"Do not argue with an idiot. He will drag you down to his level and beat you with experience.",
	"Sex is not the answer. Sex is the question. \"Yes\" is the answer.",
	"The last thing I want to do is hurt you. But it's still on the list.",
	"I'm so good even my wife wants me",
	"What do you do when your wife's staggering? Shoot her again.",
	"What does a gnome get if he runs through a womans legs? A clit round the ear and a flap across the face",
	"What did the fish say when he swam into the wall? DAMN",
	"Your god has arrived, worship me",
	"Hunter: Wow where did you tame that cat? He looks cool! Druid: -_- Hunter: WHOA HOW DID YOU MAKE IT TALK???",
	"How do you stop a Gnome from drowning? Take your foot off his head.",
	"When you are killed by a Druid, it is considered death by natural causes?",
	"Mage summons Water elemental. Water elemental opens trade window and whispers to the mage \"water plz\"",
	"Harden the fuck up",
	"Seems like the healers are on holiday again :(",
	"You cant kill me im too sexy",
	"Working as Intended",
	"Girlfriends come and go, but epic are bind on pickup.",
	"You thought u was dead didn't you, well im not ha ha",
	"I asked my wife if she enjoys a cigarette after sex and she said, \"No, one drag is enough.\"",
	"A computer once beat me at chess, but it was no match for me at kick boxing.",
	"I'm getting hit but it feels so good",
	"I'm not anti-social. I'm just not user friendly.",
	"Girls are like Internet Domain names, the ones I like are already taken.",
	"I went to buy some camouflage trousers the other day but I couldn't find any..",
	"WTB healer",
	"What do you call a Tauren with no legs? Ground beef.",
	"Do you know who invented warlocks? Someone who couldn't win a single duel with any other class",
	"What is the differens between a rat and a gnome crossing a road? There are skid marks infront of the rat....",
},
}
NuttyWarAnnounce.SoundFiles = {
	murloc = "Sound\\Creature\\Murloc\\mMurlocAggroOld.wav",
	illidan = "Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav",
	horn = "Sound\\Events\\squire_horn_aa.wav",
	raidwarning = "Sound\\Interface\\RaidWarning.wav",
	readycheck = "Sound\\Interface\\ReadyCheck.wav",
	bell = "Sound\\Doodad\\BellTollNightElf.wav",
	horn2 = "Sound\\Doodad\\DwarfHorn.wav",
	questfailed = "Sound\\Interface\\igQuestFailed.wav",
	questcomplete = "Sound\\Interface\\iQuestComplete.wav",
	train = "Sound\\Character\\BloodElf\\BloodElfFemaleTrain01.wav",
	levelup = "Sound\\Interface\\LevelUp.wav",
	youwilldie = "Sound\\Creature\\CThun\\CThunYouWillDIe.wav",
}
	
function NuttyWarAnnounce:nwasctoutputused(link)
	sctmessage = format(mstwo,link,"Used")
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end
function NuttyWarAnnounce:nwasctoutputfaded(link)
	sctmessage = format(mstwo,link,"Faded")
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end
function NuttyWarAnnounce:nwasctoutputfailed(link)	
	sctmessage = format(mstwo,link,"Failed")
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end
function NuttyWarAnnounce:nwasctoutputusedon(link,dstName)
	sctmessage = format(msthree,link,"Used on", dstName)
	NuttyWarAnnounce:addnewmessage(sctmessage)
end
function NuttyWarAnnounce:nwasctoutputfailedon(link,dstName)
	sctmessage = format(msthree,link,"Failed on", dstName)
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end
function NuttyWarAnnounce:nwasctoutputfadedon(link,dstName)
	sctmessage = format(msthree,link,"Faded on", dstName)
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end
function NuttyWarAnnounce:nwasctoutputinterruptedon(link,dstName)
	sctmessage = format(msthree,link,"Interrupted", dstName)
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end
function NuttyWarAnnounce:nwasctoutputfailedinterruptedon(link,dstName)
	sctmessage = format(msthree,link,"Failed to interrupt", dstName)
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end
function NuttyWarAnnounce:nwasctoutputbufffaded(link)
	sctmessage = format(msfour,"ALERT",link,"Faded", "ALERT")
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end
function NuttyWarAnnounce:nwasctoutputprocs(link)
	sctmessage = format(msone,link)
	NuttyWarAnnounce:addnewmessage(sctmessage,link)
end


local	nwasctFrame=CreateFrame("ScrollingMessageFrame","nwasctFrame",UIParent)
	nwasctFrame:RegisterEvent("ADDON_LOADED")
	nwasctFrame:SetScript("OnEvent", function(self, event, addon)
	if addon == "NuttyWarAnnounce" then
	nwasctFrame:SetWidth(450)
	nwasctFrame:SetHeight(250)
	NuttyWarAnnounce.db.profile.sctframe.posistion = NuttyWarAnnounce.db.profile.sctframe.posistion or {p="CENTER",r="CENTER",x=0,y=0}
	nwasctFrame:SetPoint(NuttyWarAnnounce.db.profile.sctframe.posistion.p, UIParent, NuttyWarAnnounce.db.profile.sctframe.posistion.r, NuttyWarAnnounce.db.profile.sctframe.posistion.x, NuttyWarAnnounce.db.profile.sctframe.posistion.y)	
	nwasctFrame:SetShadowColor(0.00,0.00,0.00,0.75)
	nwasctFrame:SetShadowOffset(3.00,-3.00)
	nwasctFrame:SetJustifyH("CENTER")		
	nwasctFrame:SetMaxLines(16)
	nwasctFrame:SetTimeVisible(5)
	nwasctFrame:SetFadeDuration(1)
	nwasctFrame:SetFading(true)
	nwasctFrame:SetMovable(true)
	nwasctFrame:SetClampedToScreen( true )
		end
	end)


function NuttyWarAnnounce:addnewmessage(sctmessage)
	if NuttyWarAnnounce.db.profile.nwasct then
		nwasctFrame:SetFont(Media:Fetch("font", NuttyWarAnnounce.db.profile.font), NuttyWarAnnounce.db.profile.fontsize, NuttyWarAnnounce.db.profile.fontoutline)
	local tc = NuttyWarAnnounce.db.profile.sctfc.colour
		nwasctFrame:AddMessage(sctmessage, tc.r,tc.g,tc.b)
	end
end

function NuttyWarAnnounce:FrameUpdate()
	
	nwasctFrame:EnableMouse(NuttyWarAnnounce.db.profile.lock)
	nwasctFrame:RegisterForDrag("LeftButton")
	nwasctFrame:SetScript("OnDragStart", nwasctFrame.StartMoving)
	nwasctFrame:SetScript("OnDragStop", nwasctFrame.StopMovingOrSizing)
	NuttyWarAnnounce.db.profile.sctframe.posistion.p, NuttyWarAnnounce.db.profile.sctframe.posistion.rt,NuttyWarAnnounce.db.profile.sctframe.posistion.rp,NuttyWarAnnounce.db.profile.sctframe.posistion.x, NuttyWarAnnounce.db.profile.sctframe.posistion.y = nwasctFrame:GetPoint()

	if NuttyWarAnnounce.db.profile.lock then
		nwasctFrame:SetBackdrop({
			bgFile = "Interface/Tooltips/UI-Tooltip-Background",
	})
	nwasctFrame:SetBackdropColor(0.75,0,0,1)
	else 
			nwasctFrame:SetBackdrop({
			bgFile = "nil",
	})
	nwasctFrame:SetBackdropColor(nil)
	end
	end